! linkkeyb.h
! estensione per tastiera per linklib.h
! Paolo Lucchesi, 2016

!System_File;

#IfNDef GG_MAINWIN_ROCK;  ! Prima inclusione, per i Replace

Replace DescribeRoom;
Replace GetLinkKey;
Replace LineMenu;
Replace link;
Replace ShowOptions;
Replace ShowMenu;
Replace ShowRecMenu;
Default TEXTONLY 0;
Default MENUONMAINWIN 0;
Constant LINKKEYBUSED;

#IfNot;  ! Seconda inclusione, tutto il resto
#IfDef LINKKEYBUSED; ! Verifichiamo ci sia stata la prima inclusione

#IfDef LINKKEYBWIN;
Constant GG_KEYBWIN_ROCK 291;
Global gg_keybwin;
#IfDef STATUS_WIN_UFRAME;
  Constant GG_KEYBWINUF_ROCK 292;
  Global gg_keybwinuf = 0;
#EndIf;
#EndIf;

Global klink=0;
Global klinkrem=false;
Global klinkins=0;
Global klimit=0;

Object klinklistgame;
Object klinklistmenu;

Global klinklist = klinklistgame;
Object klinklisttmp;

Class Klinko(64)
  with olk,
  create [id;
    self.olk=id;
    while(child(klinklist)) {
      if (klinkins == 0) klinkins = klink;
      move child(klinklist) to klinklisttmp;
      if (klinkins && child(klinklisttmp) == klinkins) break;
    }
    move self to klinklist;
    klinkins = self;
    while(child(klinklisttmp)) move child(klinklisttmp) to klinklist;
  ];

[ link id; 
    ! funzione o print rule
    ! link(x) inizia l'hyperlink dell'oggetto x
    ! link(0) chiude l'hyperlink
    if (id == 0) glk_set_hyperlink(0);
    if (metaclass(id) == Object) {
        glk_set_hyperlink(id);
        AddLinkToList(id);
    }
];

[ AddLinkToList id k;
    if (id == 0) rfalse;
    !if (id ofclass Dialog) print "[",(name)id,"]";
    if (klimit && id notin klimit) rfalse;
    if (id ofclass KeyLink) rfalse; !!! ???
    if (id ofclass MLink && klinklist==klinklistgame) rfalse; !!! ???
    k = child(klinklist);
    while(k) {
      if (k.olk == id) rfalse;
      k = sibling(k);
    }
    Klinko.create(id);
];

![ AddLinkToList id k;
!    if (id == 0) rfalse;
!    print (name)id;
!    if (klimit && id notin klimit) { print "K"; rfalse; }
!    if (id ofclass KeyLink) { print "C"; rfalse; } !!! ???
!    k = child(klinklist);
!    while(k) {
!      if (k.olk == id) { print "M"; rfalse; }
!      k = sibling(k);
!    }
!    print "*";
!    Klinko.create(id);
!];

[ RemoveLinkFromList kl;
    if (kl == 0) kl=klink;
    if (kl in klinklist && kl ofclass Klinko) {
      if (klink==kl) {
        if (klink) { klink=sibling(klink); klinkrem=true; }
        if (klink==0) klink=child(klinklist);
        if (klink==0 or kl) rfalse;
      }
      remove kl;
      Klinko.destroy(kl);
    }
];

[ CheckLinkInList kl x;
  !print "Check";
  if (kl == 0) kl=klink;
  if (klinklist~=klinklistgame) rfalse;
  if (~~(kl provides olk)) rfalse;
  x = kl.olk;
  !print (name)x;
  !if ((x provides condition && ~~x.condition()) || x has locked) r=true;
  if (x ofclass Dialog) {
    if (parent(x) == 0) { RemoveLinkFromList(kl); rtrue; }
    if (x has locked) { RemoveLinkFromList(kl); rtrue; }
    if (x provides condition && ~~x.condition()) { RemoveLinkFromList(kl); rtrue; }
    rfalse;
  }
  if (x ofclass Node) {
    if (~~IsNear(x)) { RemoveLinkFromList(kl); rtrue; }
    rfalse;
  }
  if (x ofclass MLink or KeyLink) rfalse; ! Questa probabilmente non serve piu'
  if ((~~TestScope(x)) && (~~TestHomonym(x))) { RemoveLinkFromList(kl); rtrue; }
  rfalse;
];

[ ClearList lst x;
  if (lst == 0) lst=klinklist;
  objectloop(x in lst && x ofclass Klinko) Klinko.destroy(x);
  klink=0;
];
    
[ DescribeRoom flag r x;
  ClearList();
  promptlinks=false;
  r = _DescribeRoom(flag);
  !objectloop (x in player) AddLinkToList(x);
  return(r);
];

![ LineMenu pmenu cont r; 
!  klinklist = klinklistmenu; ClearList(); klimit = pmenu;
!  r = _LineMenu(pmenu,cont); 
!  klinklist = klinklistgame; klink=0; klimit = 0;
!  print "^";
!  return(r);
!];

[ LineMenu pmenu cont id;
    klinklist = klinklistmenu; ClearList(); klimit = pmenu;
    if (~~cont) {
      if (pmenu provides description) print (string)pmenu.description;
      objectloop(id in pmenu)
          if (id ofclass MLink) {
              link(id);
              print "[", (string)id.command, "]";
              link(0);
              print " ";
          }
      print "^^";
    }
    while(true) {
        id = 0;
        while (id == 0) id = GetLinkKey(pmenu);
        if ((id ofclass MLink) && (id in pmenu)) {
            klinklist = klinklistgame; klink=0; klimit = 0;
            print "^";
            return(id.description());
        }
    }
    klinklist = klinklistgame; klink=0; klimit = 0;
    print "^";
    id = 0;
];

[ GetLinkKey list id x n i;
    !if (klink) DisplayKLink();
    id=GetLink();
    klinkins = klink;
    if (id < 0) {
        objectloop (x in player) AddLinkToList(x);
    #IfDef dialogline;
        if (dialogline.ndialogs>=1) AddLinkToList(dialogline.dialog1);
        if (dialogline.ndialogs>=2) AddLinkToList(dialogline.dialog2);
        if (dialogline.ndialogs>=3) AddLinkToList(dialogline.dialog3);
    #EndIf;
        CheckLinkInList();
        if (list ~= choicelinks) {
            if (keypressed == keycode_Right or 'd' or 'D') { KeybNextLink(); rfalse; }
            if (keypressed == keycode_Left or 'a' or 'A') { KeybPrevLink(); rfalse; }
#IfDef DEBUG;
            if (keypressed == keycode_Func7) { KeybLinkList(); rfalse; }
#EndIf;        
            if (keypressed == keycode_Return or ' ') { if (klink provides olk) return(klink.olk); }
        }
        objectloop(x in list && x provides keys) {
            n = x.#keys / WORDSIZE;
            for (i=0:i<n:i++) {
                if (keypressed == x.&keys-->i) return x;
            }
        }
    };
    return id;
];

#IfDef DEBUG;
[ KeybLinkList x st;
  st = GetStyle();
  SetStyle(style_User2);
  print "^";
  objectloop(x in klinklist) {
    print x;
    if (x == klink) print "*";
    PrintCommand(x.olk);
  }
  SetStyle(st);
  print ">";  
];
#EndIf; 

[ KeybNextLink;
    if (klink && (~~klinkrem)) klink=sibling(klink);
    klinkrem=false;
    if (klink==0) klink=child(klinklist);
    if (klink==0) rfalse;
    DisplayKLink();
    rtrue;
];

[ KeybPrevLink x;
    klinkrem=false;
    x=child(klinklist);
    if (x==0) rfalse;
    while(x) {
      if (sibling(x) == klink or 0) break;
      x = sibling(x);
    }
    klink = x;
    if (klink==0) rfalse;
    DisplayKLink();
    rtrue;
];

![ KeybNextLink x;
!    if (klink==0) klink=location;
!    x = klink;
!    !if (klink == location) { klink=x; break; }
!    if (child(klink)) klink=child(klink);
!    else if (sibling(klink)) klink=sibling(klink);
!    else {
!        while (parent(klink)) {
!            klink=parent(klink);
!            if (sibling(klink)) { klink=sibling(klink); break; }
!        }
!        if (klink==0) klink=x;
!    }
!    DisplayKLink();
!    rtrue;
!];

[ DisplayKLink x st;
  if (x == 0) x = klink;
#IfDef LINKKEYBWIN;
  if (gg_keybwin == 0) rfalse;
  glk_set_window(gg_keybwin);
  glk_window_clear(gg_keybwin);
#IfNot;  
  !!!glk_set_window(gg_mainwin); !!! ATTENZIONE
  st = GetStyle();
  SetStyle(style_User2);
#EndIf;
  PrintCommand(x.olk, (klinklist ~= klinklistgame));
#IfDef LINKKEYBWIN;
  glk_set_window(gg_mainwin);
#IfNot;
  SetStyle(st);
  print ">";
#EndIf;
];


#IfDef LINKKEYBWIN;
[ KeybWindowUpdate;
    KeybWindowClose();
    KeybWindowOpen();
];

[ KeybWindowOpen bg fg;
    if (gg_keybwin == 0) {
        gg_keybwin = glk_window_open(gg_mainwin, (winmethod_Below+winmethod_Fixed), 1, wintype_Textgrid, GG_KEYBWIN_ROCK);
    }
    bg = 0; fg = $FFFFFF;
#IfDef STATUS_WIN_UFRAME;
    if (gs_graphic) {
        if (glk_style_measure(gg_keybwin, style_Normal, stylehint_TextColor, gg_arguments)) 
            fg = gg_arguments --> 0;
        if (glk_style_measure(gg_keybwin, style_Normal, stylehint_BackColor, gg_arguments)) 
            bg = gg_arguments --> 0;
        if (gg_keybwinuf == 0) {
            gg_keybwinuf = glk_window_open(gg_mainwin, (winmethod_Below+winmethod_Fixed), 4, wintype_Graphics, GG_KEYBWINUF_ROCK);
        }    
        glk_window_set_background_color(gg_keybwinuf, bg); 
        glk_window_clear(gg_keybwinuf);        
        glk_window_fill_rect(gg_keybwinuf,fg,1,1,2048,2);
    }
#Endif;
    rtrue;
];

[ KeybWindowClose;
#IfDef STATUS_WIN_UFRAME;
    if (gg_keybwinuf) glk_window_close(gg_keybwinuf, 0);
    gg_keybwinuf = 0;
#Endif;
    if (gg_keybwin) glk_window_close(gg_keybwin, 0);
    gg_keybwin = 0;
    rtrue;
];

Object "linkkeyb" LibraryExtensions
  with ! request [; if (gg_keybwin) glk_request_hyperlink_event(gg_keybwin); ],
    initial [; KeybWindowOpen(); ],
    hndglkevent [ev;
      if (ev-->0 == evtype_Arrange or evtype_Redraw) { KeybWindowUpdate(); }
    ],
    idglkobject [phase type ref rock;
        if (phase == 0) gg_keybwin = 0;
        if ((phase == 1) && (type == 0) && (rock == GG_KEYBWIN_ROCK)) { gg_keybwin = ref; rtrue; }
#IfDef STATUS_WIN_UFRAME;
        if (phase == 0) gg_keybwinuf = 0;
        if ((phase == 1) && (type == 0) && (rock == GG_KEYBWINUF_ROCK)) { gg_keybwinuf = ref; rtrue; }
#Endif;          
        if (phase == 2) { KeybWindowUpdate(); }
        if (phase == 3) KeybWindowClose();
        rfalse;
    ];
#EndIf;

Stub KeybWindowUpdate 0;
Stub KeybWindowOpen 0;
Stub KeybWindowClose 0;

!!! Gestione dei menu
[  ShowOptions; "Gestione opzioni non attiva."; ];

[ ShowMenu id r; 
  !klinklist = klinklistmenu; ClearList(); klimit = id;
  r = _ShowMenu(id); 
  klinklist = klinklistgame; klink=0; klimit = 0;
  return(r);
];

[ ShowRecMenu id r pk; 
  pk = klimit;
  klinklist = klinklistmenu; ClearList(); klimit = id;
  r = _ShowRecMenu(id); 
  ClearList(); klimit = pk;
  print "^";
  return(r);
];


#EndIf;
#EndIf; ! Fine seconda inclusione